//+---------------------------------------------------------------------------------------------------------+
//|                                                                                PathFunctions.mqh        |
//|                                                                                Copyright  Zhunko       |
//|29.05.2011 - 27.02.2014                                                         MF ZHUNKO vadim@zhunko.ru|
//+---------------------------------------------------------------------------------------------------------+
//|    "PathFunctions.dll"       MetaTrader. |
//+---------------------------------------------------------------------------------------------------------+
//|        Windows Vista  .                                       |
//+---------------------------------------------------------------------------------------------------------+

#ifndef size_t
 #ifdef  TERMINAL_X64
  #define size_t      ulong
 #else
  #define size_t      uint
 #endif
#endif

#ifndef BOOL
 #define BOOL int
#endif

//    "PathGetList()". 
#define GL_FOLDER       1 //    .
#define GL_FILE         2 //    .
#define GL_ALL          3 //     .

//
#import "PathFunctions.dll"
 //
 //          .
 //
 // 1.1.    .   ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathCheckA(uchar &szPath[]); //   .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 1.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathCheckW(string sPath); //   
 //=======================================================================================================================================================================================================================================
 // 2.1.       (  ).    ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathClearContentsA(uchar &szPath[]); //           .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 2.2.       (  ).    ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathClearContentsW(string sPath); //           .
 //=======================================================================================================================================================================================================================================
 // 3.1.         .    ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathClearFromFilesA(uchar &szPath[]); //           .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 3.2.         .    ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathClearFromFilesW(string sPath); //           .
 //=======================================================================================================================================================================================================================================
 // 4.1.    ,    .   ,    .
 //          .   ,   TRUE,  - FALSE.
 //         ANSI-.
 BOOL PathCopyA(uchar &szExistingPath[], //     .
                uchar &szNewPath[]);     //     .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 4.2.    ,    .   ,    .
 //          .   ,   TRUE,  - FALSE.
 //         UNICODE-.
 BOOL PathCopyW(string sExistingPath, //     .
                string sNewPath);     //     .
 //=======================================================================================================================================================================================================================================
 // 5.1.   .      ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathCreateA(uchar &szPath[]); //    .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 5.2.   .      ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathCreateW(string sPath); //    .
 //=======================================================================================================================================================================================================================================
 // 6.1.    .   ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathDeleteA(uchar &szPath[]); //   .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 6.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathDeleteW(string sPath); //   .
 //=======================================================================================================================================================================================================================================
 // 7.1.    .   ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathDeleteEmptyA(uchar &szPath[]); //   .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 7.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathDeleteEmptyW(string sPath); //   .
 //=======================================================================================================================================================================================================================================
 // 8.1.     /    MQLSTR-      .      / .
 //              0.    ANSI-.
 size_t PathGetListMA(uchar  &szPath[],    //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                           //   ,         .      ,
                                           //    ,               .
                      int     nSearch,     //   : GL_FOLDER -   .
                                           //                      GL_FILE   -   .
                                           //                      GL_ALL    -    .
                      string &asList[],    //     MQLSTR-      .
                                           //              .
                      size_t  stSizeList); //       .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 8.2.     /    MQLSTR-      .      / .
 //              0.    UNICODE-.
 size_t PathGetListMW(string  sPath,      //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                          //   ,         .      ,
                                          //    ,               .
                     int     nSearch,     //   : GL_FOLDER -   .
                                          //                      GL_FILE   -   .
                                          //                      GL_ALL    -    .
                     string &asList[],    //     MQLSTR-      .
                                          //              .
                     size_t  stSizeList); //       .
 //=======================================================================================================================================================================================================================================
 // 9.1.     .   TRUE,      FALSE,         .    ANSI-.
 BOOL PathIsEmptyA(uchar &szPath[]); //   .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 // 9.2.     .   TRUE,      FALSE,         .    UNICODE-.
 BOOL PathIsEmptyW(string sPath); //   .
 //=======================================================================================================================================================================================================================================
 //10.1.   ()  ,    .    ,   TRUE,  - FALSE.    ANSI-.
 BOOL PathMoveA(uchar &szExistingPath[], //     .
                uchar &szNewPath[]);     //     .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //10.2.   ()  ,    .    ,   TRUE,  - FALSE.    UNICODE-.
 BOOL PathMoveW(string sExistingPath, //     .
                string sNewPath);     //     .
 //=======================================================================================================================================================================================================================================
 //11.1.       .    ,   TRUE,  - FALSE.      .    ANSI-.
 BOOL PathSymbolicLinkA(uchar &szExistingDirectory[],      //   .
                        uchar &szSymbolicLinkDirectory[]); //     .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //11.2.       .    ,   TRUE,  - FALSE.      .    UNICODE-.
 BOOL PathSymbolicLinkW(string sExistingDirectory,      //   .
                        string sSymbolicLinkDirectory); //     .
 //=======================================================================================================================================================================================================================================
 //12.1.                  ,   .       .    ANSI-.
 //          ,          .           ,   ,    ,   .
 string PathTrimNameFileA(uchar &szPathFull[]); //  .
 //---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
 //12.2.                  ,   .       .    UNICODE-.
 //          ,          .           ,   ,    ,   .
 string PathTrimNameFileW(string sPathFull); //  .
 //
#import
//
/*
27.02.2014.  4.2.27.0.
1.    64- .
2.         PathGetListMA(), PathGetListMW().       .
 
*/